<?php
/**
 * This file is part of
 *
 * SiriusGallery
 *
 * for pragmamx (www.pragmamx.org)
 *
 * $Version 1.0 $
 * $Author: Olaf Herfurth / TerraProject  http://www.tecmu.de $
 * $Date: 2011/05/01 $
 *
 */



defined('mxMainFileLoaded') or die('access denied');

// Variablen definieren

$module_name=basename(dirname(__FILE__));
$wysiwyg = 0;
$wysiwyg_content = 0;
define("_SG_MAIN",true);

if (empty($ok)) $ok = 0;
if (empty($cat)) $cat=0;
if (empty($pic)) $pic=0;
if (empty($size)) $size=0;
if (empty($page)) $page=0;

if (!isset($act)) $act="" ;
if (!isset($list)) $list="" ;
if (!isset($keyword)) $keyword="";

// SPrachdateien einbinden
mxGetLangfile($module_name);
mxGetLangfile($module_name,"user.lang-*.php");

include_once (PMX_MODULES_PATH .$module_name.DS."core".DS."tabledef.php");
include_once (PMX_MODULES_PATH .$module_name.DS."inc".DS."functions.php");
include_once (PMX_MODULES_PATH .$module_name.DS."inc".DS."functions.sirius.php");
include_once (PMX_MODULES_PATH .$module_name.DS."inc".DS."functions.comments.php");
//require_once("modules/$module_name/inc/exif/exifReader.php");

$SGCFG=getConfigAll();

if (!isset($width)) $width=100 ;
if (!isset($height)) $height=100 ;
if (!isset($quality)) $quality=80 ;

/**
 * rechte Bloecke festlegen
 */

$index=$SGCFG['RIGHTBLOCKS'];

switch ($act) {
	case "slideshow":
	    sg_ViewSlideshow($cat);
		break;
	case "vote":
	    sg_picVote($pic);
		break;
	case "detail":
	    sg_ViewImage($pic);
		break;
	case "unlock":
	    sg_catUnlock($cat);
		break;
	case "getimage":
	    sg_getImage($pic,$size);
		break;
	case "fullsize":
	    sg_getImage($pic,2);
		break;
	case "cropped":
		$cimg=sg_Image($pic);
	    create_cropped_image($cimg['orig_url'], "", $width, $height, $quality );
		break;
	case "slidepic":
	    sg_getImageSlideshow($pic);
		break;	
	case "download":
	    sg_getImageDownload($pic,$size);
		break;
    case 'mygallery':
	    include (PMX_MODULES_PATH .$module_name.DS."userfunc".DS."mygallery.php");
		break;
    case 'userinfo':
	    $op="owner";
	    include (PMX_MODULES_PATH .$module_name.DS."userfunc".DS."mygallery.php");
		break;
	case "newest":
	case "top":
	case "mostviewed":
	case "random":
	case "newcomments":
		sg_ViewLists($act,$page);
		break;
	case "search":
		sg_ViewSearchList($keyword);
		break;
	case "commentsave":
		sgCommentsFormSave();
		break;
	case "commentdelete":
		sgCommentsDelete($pic);
		break;
	default:
	 main($cat,$page);
	 break;	
}


function main($cat,$page) {
    global $prefix, $currentlang,$module_name, $bgcolor1, $bgcolor2, $bgcolor3, $SGCFG,$mxConf,$pagetitle;
    
	/* das globale Template einstellen */
	//pmxHeader::set_title(_CONTENTCATEGORIES);
	$page=intval($page);
	
	if (!sg_isCategoryAllowed($cat) && $cat!=0) mxErrorScreen(_GROUPRESTRICTEDAREA);
	$userdata = mxGetUserData();
	$userid=(MX_IS_USER)?$userdata['uid']:0;
	$xcat=array();
	$xcat=sg_getCategory($cat);
	if ($cat!=0) if ($xcat['alb_pass_id'] > 0 and !mxSessionGetVar("sgid".$xcat['alb_pass_id']) and ($xcat['userid'] !=$userid)) mxRedirect("modules.php?name=$module_name&act=unlock&cat=$cat");
	
	$categories=array();
	$pictures=array();
	$pcat=$cat;
	$categories=sg_getCategoryView($cat);
	$categorycount=count($categories);
	
	$pictures=sg_getImagesView($cat,intval($page*$SGCFG['FRONT_VIEWS']),$SGCFG['FRONT_VIEWS']);
	$picturescount=count($pictures);
	
	$maximage=sg_getImagesCount($cat);
	$pagestart=($page>0)?$page:0;
	$pagecount=($SGCFG['FRONT_VIEWS']>0)?intval($maximage/$SGCFG['FRONT_VIEWS'] + 1 ):0;
	$prepage=($pagestart>0 && $SGCFG['FRONT_VIEWS']>0)?"modules.php?name=$module_name&amp;cat=$cat&amp;page=".($pagestart-1):"";
	$nextpage=($maximage>(($page+1)*intval($SGCFG['FRONT_VIEWS'])) && $SGCFG['FRONT_VIEWS']>0)?"modules.php?name=$module_name&amp;cat=$cat&amp;page=".($pagestart+1):"";
	
	$slideshowlink=($SGCFG['FRONT_SLIDESHOWLINK']>0 and $picturescount>1 )?"modules.php?name=$module_name&amp;cat=$cat&amp;act=slideshow":"";
	
	$cattitle=sg_getCategoryTitle($cat);
	
	$pageheadtitle=($cat==0)?$SGCFG['TITLE']:$SGCFG['TITLE']." - ".$cattitle;
	$pagesubtitle=($cat==0)?$SGCFG['TITLE']:$cattitle;
	$pagetext=($cat==0)?$SGCFG["GENERAL_TEXT"]:sg_getCategoryText($cat);
	$breadcrump=sg_Breadcrump($cat);
	
	$seltemplate=($cat==0 or $xcat['config']['FRONT_TEMPLATE']=="0")?$SGCFG['FRONT_TEMPLATE']:$xcat['config']['FRONT_TEMPLATE'];
	$templatepath=PMX_MODULES_PATH .$module_name.DS."templates".DS.$seltemplate.DS;
	$defaulttemplate="default".DS;
	
	
	/* standardnamen im default-template initialisieren*/
	$view_category=$seltemplate."categories.html";
	$view_description=$seltemplate."description.html";
	$view_navigation=$seltemplate."navigation.html";
	$view_detail=$seltemplate."detail.html";
	$view_pictures=$seltemplate."pictures.html";
    $view_blocks=$seltemplate."/blocks.html";
	
	include('header.php');
	pmxHeader::add_style("modules".DS.$module_name.DS."style".DS."style.css");
	pmxHeader::add_style("modules".DS.$module_name.DS."style".DS."blocks.css");
	
	//$templatename=$SGCFG['FRONT_TEMPLATE'];
	if (is_file($templatepath."blocks.css")) {
	    pmxHeader::add_style($templatepath."blocks.css");
	} else {
	}
	$file_tempsettings=$templatepath."category.settings.php";
	if (file_exists($file_tempsettings)) include($file_tempsettings);
	if ($SGCFG['FRONT_DESCRIPTION']==0) $pagetext="";
	
	if ($cat==0 and $SGCFG['FRONT_LISTS']==1) {
	
		$pagetext .= "<br /><hr><div class=\"block align-center\">";
		$pagetext .= "	<a class=\"sgButton\" href=\"modules.php?name=SiriusGallery&amp;act=newest\" >"._SG_NEWEST_PICTURES."</a>";
		$pagetext .= "	<a class=\"sgButton\" href=\"modules.php?name=SiriusGallery&amp;act=mostviewed\" >"._SG_MOSTVIEWED_PICTURES."</a>";
		if ($SGCFG["USER_VOTING"]==1) $pagetext .= "	<a class=\"sgButton\" href=\"modules.php?name=SiriusGallery&amp;act=top\" >"._SG_TOPRATED_PICTURES."</a>";
		$pagetext .= "	<a class=\"sgButton\" href=\"modules.php?name=SiriusGallery&amp;act=random\" >"._SG_RANDOM_PICTURES."</a>";
		if ($SGCFG["USER_COMMENTS"]==1) $pagetext .= "	<a class=\"sgButton\" href=\"modules.php?name=SiriusGallery&amp;act=newcomments\" >"._SG_NEWCOMMENT_PICTURES."</a><br />";
		$pagetext .= "	</div>";
	}	
	
	$mygallerylink=(MX_IS_USER && $SGCFG["USER_USERGALLERY"]==1)?"<a href=\"modules.php?name=".$module_name."&amp;act=mygallery\" title=\""._SG_MYGALLERY."\" class=\"sgButton\">"._SG_MYGALLERY."</a>&nbsp;&nbsp;":"";

	/* Template initialisieren */
	$template = load_class('Template');
	$template->init_path(__FILE__);
	/* Daten dem Template zuweisen */
	$template->pagetitle = $pageheadtitle;
	$template->pagesubtitle = $pagesubtitle;
	$template->breadcrump = $breadcrump;
	$template->searchlink=$mygallerylink . "<a href=\"modules.php?name=$module_name&amp;act=search\" class=\"sgButton\">".SG_SEARCH."</a>";
	$template->pagetext = mxPrepareToDisplay($pagetext);
	$template->categories = $categories;
	$template->category = $xcat;
	$template->categorycount = $categorycount;
	$template->categoriestitle = _SG_CATEGORIES;
	$template->picturestitle = _SG_IMAGES;
	$template->categorynum = $pcat;	
	
	$template->pictures = $pictures;
	$template->picturescount = $picturescount;
	$template->slidelink=$slideshowlink;
	$template->adminlink=((MX_IS_ADMIN)?"<a href=\"admin.php?op=".$module_name."\" title=\""._ADMINMENUEBL."\" >["._ADMINMENUEBL."]</a>":"");
	$template->modulname=$module_name;
	
	/* fr Navigation */
	$template->page=$page+1 ;	
	$template->pages=$pagecount;
	$template->pagepre = $prepage;
	$template->pagenext= $nextpage;
	
	/* Template ausgeben (display) */
	
	if ($SGCFG['FRONT_BREADCRUMP']==1) $template->display('breadcrump.html');
	$template->display('pagestart.html');
	$template->display($view_description);
	
	$template->display($view_category);
	
	if ($SGCFG["FRONT_PAGES"]!=1)  $template->display($view_navigation);
	
	$template->display($view_pictures);
	
	if ($SGCFG["FRONT_PAGES"]>0)  $template->display($view_navigation); //&& $SGCFG['FRONT_VIEWS']!=0 && $maximage > $SGCFG['FRONT_VIEWS'])
	
	if ($SGCFG['FRONT_BLOCKS']>0) {
		$blockcontent="";
		$viewblock=unserialize($SGCFG['FRONT_BLOCKSNUM']);
		$blocksview=true;
		
		foreach ($viewblock as $value) {
		    $block_images=array();		// enthlt alle anzuzeigenden Bilder
			$block_title="";			// enthlt den Blocktitel
			str_replace("-","",$value);
			   if (!empty($value)) {
					 $blockfile="modules".DS.$module_name.DS."blocks".DS."gallery".DS.$value."";
					 if (file_exists($blockfile)) include ($blockfile);
					 //$blockcontent .="".$content."";
		
					if ($SGCFG['FRONT_BLOCKS_SUBS']==0 and $cat>0 and !sg_isUserCategory($cat) )$blocksview=false;
					if ($SGCFG['FRONT_BLOCKS_USER']==0 && $cat>1 && sg_isUserCategory($cat) ) $blocksview=false;
						
					$template->actualblocks = $SGCFG['FRONT_BLOCKS_ACTUAL_CAT'];
					
					if ($blocksview) {
						$template->block_title=$block_title;
						$template->blocks=$blockcontent;
						$template->block_images=$block_images;
						$template->display($view_blocks);
					}
			
			   }
			unset ($block_images);
		}
	}
	
	$template->display('pageend.html');	
	getAutoTemplate();
	include('footer.php');
   

}

function sg_ViewImage($pic) {
    global $prefix, $currentlang,$module_name, $bgcolor1, $bgcolor2, $bgcolor3, $SGCFG,$mxConf,$pagetitle;
    
	
	$result=sql_query("select aid from ".SG_TABLE_PICTURE." where pid=$pic");
	if (sql_num_rows($result)==0) mxRedirect("modules.php?name=$module_name");
	$image=array();
	//$image=sql_fetch_row($result);
	list($cat)=sql_fetch_row($result);
	
	if ($SGCFG['CAT_DETAIL']==0 ) mxRedirect("modules.php?name=$module_name&amp;cat=$cat");
	
	$userdata = mxGetUserData();
	$userid=(MX_IS_USER)?$userdata['uid']:0;
	$xcat=array();
	$xcat=sg_getCategory($cat);
	if ($cat!=0) if ($xcat['alb_pass_id'] > 0 and !mxSessionGetVar("sgid".$xcat['alb_pass_id']) and ($xcat['userid'] !=$userid)) mxRedirect("modules.php?name=$module_name&act=unlock&cat=$cat");

	 	
	$seltemplate=($cat==0 or $xcat['config']['FRONT_TEMPLATE']=="0")?$SGCFG['FRONT_TEMPLATE']:$xcat['config']['FRONT_TEMPLATE'];
	

	if (!sg_isCategoryAllowed($cat) ) mxErrorScreen(_GROUPRESTRICTEDAREA);
	
	$pictures=sg_getImagesView($cat);  // alle Images von dem Album - fr evtl. Slideshow
	foreach ($pictures as $images=>$ximage) {
	  if ($ximage['pid']==$pic) $image=$ximage; // hier anzuzeigendes Bild raussuchen
	}
	if (!array_key_exists('published',$image)) mxRedirect("modules.php?name=$module_name&amp;cat=$cat");
	if ($image['published']<1 ) mxErrorScreen(_GROUPRESTRICTEDAREA);
	
	$image['previmg']="";
	$image['nextimg']="";
	foreach ($pictures as $catimg => $img) { 
		if(intval($img['position']) == intval($image['position'])-1 ) $image['previmg']=$img['link_url'];
		if(intval($img['position']) == intval($image['position'])+1 ) $image['nextimg']=$img['link_url'];
	}
	// Adminlink
	
	$adminlink=(($img['userid'] ==$userid) and MX_IS_USER)?" <a href=\"modules.php?name=".$module_name."&amp;act=mygallery&amp;op=picedit&amp;pic=$pic\" title=\""._EDIT."\" >["._EDIT."]</a>&nbsp;":"";
	$adminlink .=((MX_IS_ADMIN)?"<a href=\"admin.php?op=".$module_name."\" title=\""._ADMINMENUEBL."\" >["._ADMINMENUEBL."]</a>":"");
	
	$ratingimg="<img src=\"modules/$module_name/style/img/star.png\" alt=\"\" title=\"".$image['rating']."/".$SGCFG['USER_VOTING_MAX']."\" />";
	$ratingimgmax="<img src=\"modules/$module_name/style/img/star_blank.png\" alt=\"\" title=\"".$image['rating']."/".$SGCFG['USER_VOTING_MAX']."\" />";
	$imagerating=str_repeat($ratingimg,round($image['rating'])).str_repeat($ratingimgmax,round($SGCFG['USER_VOTING_MAX']-$image['rating']));
	
	$image['rating']=($image['rating']>0)?$imagerating." <span class=\"tiny\" style=\"margin-left:10px;\" >( ".$image['votes']." "._SG_RATINGS." )</span>":_SG_RATING_NONE;
	
	$breadcrump=sg_Breadcrump($cat);
	
	/* standardnamen im default-template*/
	$templatepath=PMX_MODULES_PATH .$module_name.DS."templates".DS.$seltemplate.DS;
	$defaulttemplate="default".DS;
	$view_detail=$seltemplate."detail.html";
	
	// Details Data from Picture
	$imgdata=array();
	
	
	/* EXIF Data */
	
		
		 /**
		 * Create an object
		 
		 $exifimg=sg_getImage($pic);
		 $er = new phpExifReader($exifimg['orig_url']);*/
		
		 /*
		  * Process the JPEG image
		  */
		 //$er->processFile();
		
		 /**
		  * Generate a Link to view thumbnail.
		  * showThumbnail.php files need to be in the same directory.
		 
		 if($er->ThumbnailSize > 0) {
				echo "<br><img src='".$er->showThumbnail()."'>";
		 } */
		 /**
		  * Show the image details along with Exif information.
		 
		 echo "<pre>";
			print_r($er->getImageInfo());
		 echo "</pre>";
		
		$imgdata=$er->getImageInfo(); */
		
		
	$imgdata=sg_getImageData($image);
	unset($imgdata['orig_url']);
    $username=mxGetUserDataFromUid($image['userid']);
	// hier beginnt die Ausgabe
	include('header.php');
	if ($SGCFG['USER_RIGHTCLICK']==1 ) onClick();		//rechtsklick sperren
	
	pmxHeader::add_style("modules".DS.$module_name.DS."style".DS."style.css");
	pmxHeader::add_style("modules".DS.$module_name.DS."style".DS."blocks.css");
	
	//$templatename=$SGCFG['FRONT_TEMPLATE'];
	if (is_file("modules".DS .$module_name.DS."templates".DS.$seltemplate.DS."blocks.css")) {
	  pmxHeader::add_style("modules".DS.$module_name.DS."template".DS.$seltemplate.DS."blocks.css");
	} 

	$file_tempsettings=$templatepath."detail.settings.php";
	if (file_exists($file_tempsettings)) include($file_tempsettings);
		
	/* Template initialisieren */
	$template = load_class('Template');
	$template->init_path(__FILE__);
	/* Daten dem Template zuweisen */
	$template->templatepath=$templatepath;   // Pfad des Templates
	$template->pagetitle = mxPrepareToDisplay($image['title']);
	$template->pagesubtitle = mxPrepareToDisplay($image['title']);
	$template->breadcrump = $breadcrump;
	$template->adminlink = $adminlink;
	//$template->picture = mxPrepareToDisplay($image['pic_url']);
	$template->piclink = $image['orig_url'];
	$template->searchlink="<a href=\"modules.php?name=$module_name&amp;act=search\" class=\"sgButton\">"._SEARCH."</a>";
	$template->modulname=$module_name;

	$template->title = mxPrepareToDisplay($image['title']);
	$template->picture= $image;  // Daten vom aktuellen Bild
	
	$imgopt="<a href=\"".$image['orig_url']."\" rel=\"pretty\" title=\"".mxPrepareToDisplay($image['title'])."\" ><img src=\"modules/$module_name/style/img/zoom.png\" height=\"16\" width=\"16\" alt=\"\"  /></a>";
	$imgoptuser=0;
	if ($SGCFG['IMG_DOWNLOAD']==1) {
		switch($SGCFG['IMG_DOWNLOAD_USER']) {
			case 0:		// all
				$imgoptuser=1;
			break;
			case 1:		// user only
				if (MX_IS_USER or MX_IS_ADMIN) $imgoptuser=1;
			break;
			case 2:		// admin only
				if (MX_IS_ADMIN) $imgoptuser=1;
			break;
		}
		$imgopt .= ($imgoptuser==1)?"&nbsp;<a href=\"modules.php?name=$module_name&amp;act=download&amp;pic=$pic&amp;size=2\" class=\"imgoption\"><img src=\"modules/$module_name/style/img/disk.png\" height=\"16\" width=\"16\" alt=\"\" /></a>":"";
	}
	$template->imgoption=$imgopt;
	
	
	// Keywords
	$keywordarray=array();
	$keywordlink="";
	if ($image['keywords']!="") {
	
	   
	   $keywords=mxPrepareToDisplay($image['keywords']);
	   
 	   pmxHeader::add ("<meta name=\"keywords\" content=\"SiriusGallery,tecmu,".$keywords."\" />");
	   
	   $keywords=htmlentities(str_replace(","," ",$keywords));
	   $keywordarray= explode(" ",$keywords);
	   foreach($keywordarray as $key =>$value) {
	     $keywordlink .="<a class=\"sgkeywords\" href=\"modules.php?name=$module_name&amp;act=search&amp;keyword=$value\">$value</a>&nbsp;";
	   }
	   $imgdata[IMG_KEYWORDS]=$keywordlink;
	}
	
	$template->imgdata=$imgdata;
	
	$template->pictures = $pictures;  // Bildcontainer fr alle Bilder der Kategorie
	$template->picturescount=count($pictures); // Anzahl der Bilder
	$template->picturepos=$image['position']; // aktuelle Nummer des Bild
	
	
	/* Voting-Formular */
	$voteform="";
	if ($SGCFG['USER_VOTING']==1 && $xcat['votes']==1) {
		$sgvotesec=md5(uniqid(rand(), TRUE));
		if (!isset($_COOKIE["sgpicvote-".$pic])) mxSessionSetVar("sgpicvote".$pic,$sgvotesec);
		$voteform .="<div class=\"align-center\" style=\"margin-bottom:15px;\">";
		$voteform .="<div class=\"tableheader\"><h4>"._SG_RATING."</h4></div>";
		$voteform .="<form method=\"post\" name=\"sgpicvote\" action=\"modules.php?name=$module_name&amp;act=vote&amp;pic=$pic\">";
		$voteform .=""._SG_RATING_BAD."&nbsp;";
		   for ($i=1;$i<($SGCFG['USER_VOTING_MAX']+1);$i++) {
			  $checked=($i>($SGCFG['USER_VOTING_MAX']/2-0.5) and $i<=($SGCFG['USER_VOTING_MAX']/2+0.5))?"checked=\"checked\"":"";
			$voteform .="<input type=\"radio\" name=\"picvote\" value=\"$i\" $checked />&nbsp;&nbsp;";
		   }
		$voteform .=""._SG_RATING_GOOD."&nbsp;";
		$voteform .="<br /><input type=\"submit\" value=\""._SG_VOTE."\" class=\"sgButton\"/>";
		$voteform .="<input type=\"hidden\" name=\"pic\" value=\"$pic\" />";
		$voteform .="<input type=\"hidden\" name=\"security\" value=\"$sgvotesec\" />";
		$voteform .="</form>";
		
		$voteform .="</div><hr>";
	}
	$template->voteform=$voteform;
	
	/* Kommentare */
	
	$template->comments=sgCommentsShow($pic) ;
		
	if ($SGCFG['USER_COMMENTS']==1 && $xcat['comments']==1) {
	    $template->commentform=sgCommentsForm ($pic,0,"modules.php?name=".$module_name."&amp;act=detail&amp;pic=$pic");
		} else {
		$template->commentform="";
	}
	
	/* Template ausgeben (display) */
	
	if ($SGCFG['FRONT_BREADCRUMP']==1) $template->display('breadcrump.html');
	$template->display('pagestart.html');
	$template->display($view_detail);
	$template->display('pageend.html');

	if (!mxSessionGetVar("sgpic".$pic)){
		sg_updateImageCount($pic)   ;
		mxSessionSetVar("sgpic".$pic,true);
	}
	getAutoTemplate();
	include('footer.php');

}


function sg_catUnlock($cat) {
    global $prefix, $currentlang,$module_name, $bgcolor1, $bgcolor2, $bgcolor3, $SGCFG,$mxConf,$pagetitle;

	if (!sg_isCategoryAllowed($cat) && $cat!=0) mxErrorScreen(_GROUPRESTRICTEDAREA);

	$xcat=array();
	$xcat=sg_getCategory($cat);
	$xerror=_SG_PASSEMPTY;
    $errhelp="";
	
	if (isset($_POST['catpass'])) {
	    // Passwort eingegeben
	    if  ($_POST['catpass']== $xcat['alb_password']) { 
		    // Passwort korrekt
			$xerror="";
			mxSessionSetVar("sgid".$cat,true);
			mxRedirect("modules.php?name=$module_name&cat=$cat");
		} else {
	        // Passwort Falsch
	    	$xerror=_SG_PASSERROR;
		}
	    //if (empty($_POST['catpass'])) $xerror=_SG_PASSEMPTY;
	} 
	
	$seltemplate=($cat==0 or $xcat['config']['FRONT_TEMPLATE']=="0")?$SGCFG['FRONT_TEMPLATE']:$xcat['config']['FRONT_TEMPLATE'];
	$cattitle=sg_getCategoryTitle($cat);
	$pageheadtitle=($cat==0)?$SGCFG['TITLE']:$SGCFG['TITLE']." - ".$cattitle;
	$pagesubtitle=($cat==0)?$SGCFG['TITLE']:$cattitle;
	$pagetext=($cat==0)?$SGCFG["GENERAL_TEXT"]:sg_getCategoryText($cat);
	$breadcrump=sg_Breadcrump($cat);


	include('header.php');
	pmxHeader::add_style("modules".DS.$module_name.DS."style".DS."style.css");
	pmxHeader::add_style("modules".DS.$module_name.DS."style".DS."blocks.css");
	
	$templatename=$SGCFG['FRONT_TEMPLATE'];
	if (is_file("modules".DS .$module_name.DS."templates".DS.$templatename.DS."blocks.css")) {
	  pmxHeader::add_style("modules".DS.$module_name.DS."template".DS.$templatename.DS."blocks.css");
	} 
			
	/* Template initialisieren */
	$template = load_class('Template');
	$template->init_path(__FILE__);
	/* Daten dem Template zuweisen */
	$template->cat = $cat;
	$template->modulname = $module_name;
	$template->pagetitle = $pageheadtitle;
	$template->pagesubtitle = $pagesubtitle;
	$template->breadcrump = $breadcrump;
	$template->pagetext = _SG_CATEGORY_UNLOCK;
	$template->category = $xcat;
	$template->xerror = $xerror;
	$template->back = _GOBACK;
	$template->help = $errhelp;
	$template->modulname=$module_name;
	$template->adminlink=(MX_IS_ADMIN)?"<a href=\"admin.php?op=".$module_name."\" title=\""._ADMINMENUEBL."\" >["._ADMINMENUEBL."]</a>":"";
	
	/* Template ausgeben (display) */
	
	$template->display('pagestart.html');
	$template->display('unlock.html');
	$template->display('pageend.html');
	getAutoTemplate();
	include('footer.php');
   
 
}   
function sg_viewSlideshow($cat) {
    global $prefix, $currentlang,$module_name, $bgcolor1, $bgcolor2, $bgcolor3, $SGCFG,$mxConf,$pagetitle;
    
	if ($SGCFG['FRONT_SLIDESHOWLINK']==0 ) mxErrorScreen(_GROUPRESTRICTEDAREA);
	
	if (!sg_isCategoryAllowed($cat) && $cat!=0) mxErrorScreen(_GROUPRESTRICTEDAREA);
	$userdata = mxGetUserData();
	$userid=(MX_IS_USER)?$userdata['uid']:0;
	$xcat=array();
	$xcat=sg_getCategory($cat);
	if ($cat!=0) if ($xcat['alb_pass_id'] > 0 and !mxSessionGetVar("sgid".$xcat['alb_pass_id']) and ($xcat['alb_pass_id'] !=$userid)) mxRedirect("modules.php?name=$module_name&act=unlock&cat=$cat");
	$pcat=$cat;
	//$categories=array();
	$pictures=array();
	
	$pictures=sg_getImagesView($cat,0,0,false);
	$picturescount=count($pictures);
		
	
	$seltemplate=($cat==0 or $xcat['config']['FRONT_TEMPLATE']=="0")?$SGCFG['FRONT_TEMPLATE']:$xcat['config']['FRONT_TEMPLATE'];
	$cattitle=sg_getCategoryTitle($cat);
	$pageheadtitle=($cat==0)?$SGCFG['TITLE']:$SGCFG['TITLE']." - ".$cattitle;
	$pagesubtitle=($cat==0)?$SGCFG['TITLE']:$cattitle;
	$pagetext=($cat==0)?$SGCFG["GENERAL_TEXT"]:sg_getCategoryText($cat);
	$breadcrump=sg_Breadcrump($cat);
	
	$templatepath=PMX_MODULES_PATH .$module_name.DS."templates".DS.$seltemplate.DS;
	$defaulttemplate="default".DS;
	
	
	/* standardnamen im default-template initialisieren*/
	$view_slideshow=$seltemplate."slideshow.html";
	

	include('header.php');
	pmxHeader::add_style("modules".DS.$module_name.DS."style".DS."style.css");
	pmxHeader::add_style("modules".DS.$module_name.DS."style".DS."blocks.css");
	
	$templatename=$SGCFG['FRONT_TEMPLATE'];
	if (is_file("modules".DS .$module_name.DS."templates".DS.$templatename.DS."blocks.css")) {
	  pmxHeader::add_style("modules".DS.$module_name.DS."template".DS.$templatename.DS."blocks.css");
	} 
	$file_tempsettings=$templatepath."slideshow.settings.php";
	//if (file_exists($file_tempsettings)) 
	include($file_tempsettings);
		
		

	/* Template initialisieren */
	$template = load_class('Template');
	$template->init_path(__FILE__);
	/* Daten dem Template zuweisen */
	$template->pagetitle = $pageheadtitle;
	$template->pagesubtitle = $pagesubtitle;
	$template->breadcrump = $breadcrump;
	$template->pagetext = mxPrepareToDisplay($pagetext);
	//$template->categories = $categories;
	$template->category = $xcat;
	$template->searchlink="<a href=\"modules.php?name=$module_name&amp;act=search\" class=\"sgButton\">".SG_SEARCH."</a>";
	//$template->categorycount = $categorycount;
	$template->categoriestitle = _SG_CATEGORIES;
	$template->picturestitle = _SG_IMAGES;
	$template->modulname=$module_name;
	$template->adminlink=(MX_IS_ADMIN)?"<a href=\"admin.php?op=".$module_name."\" title=\""._ADMINMENUEBL."\" >["._ADMINMENUEBL."]</a>":"";
	
	
	$template->pictures = $pictures;
	$template->picturescount = $picturescount;

	
	/* Template ausgeben (display) */
	
	if ($SGCFG['FRONT_BREADCRUMP']==1) $template->display('breadcrump.html');
	$template->display('pagestart.html');
	
	$template->display($view_slideshow);
	
	$template->display('pageend.html');	
	getAutoTemplate();
	include('footer.php');
   

}

function sg_picVote($pic) {
    global $prefix, $currentlang,$module_name, $bgcolor1, $bgcolor2, $bgcolor3, $SGCFG;

		$userdata = mxGetUserData();
		$userid=(MX_IS_USER)?$userdata['uid']:0;
		
		if(isset($_COOKIE["sgpicvote[".$pic."]"]) )mxRedirect("modules.php?name=$module_name&amp;act=detail&amp;pic=$pic",_SG_VOTE_ERR,3);
		
		$sgseccode=mxSessionGetVar("sgpicvote".$pic);
		$psec=$_POST['security'];
		$ppic=$_POST['pic'];
		$pvote=$_POST['picvote'];
		
		$votenums=($userid>0)?sql_num_rows(sql_query("select pid from ".SG_TABLE_VOTES." where pid=$pic and userid=$userid")):0;
		
		$picture=sg_Image($pic);

		setcookie('sgpicvote['.$pic.']',0,time()+84000*356);
		
		if ($picture['userid']==$userid and MX_IS_USER) mxRedirect("modules.php?name=$module_name&amp;act=detail&amp;pic=$pic",_SG_VOTE_ERROWNER,3);
		
		if ($sgseccode==$psec and $ppic==$pic and $votenums==0) {
				// wenn ok, dann auch das Formular gesichert und noch nicht gevotet
				sql_query("insert into ".SG_TABLE_VOTES." set userid='".$userid."', 
								pid='".$ppic."',
								vote='".$pvote/$SGCFG['USER_VOTING_MAX']."',
								ip='".$_SERVER['REMOTE_ADDR']."'
								");
				$result=sql_query("select SUM(vote), count(pid) from ".SG_TABLE_VOTES." where pid=$pic");		
				list($svote,$scount)=sql_fetch_row($result);
				sql_query("update ".SG_TABLE_PICTURE." set rating='".$svote/$scount."', votes='".$scount."' where pid=$pic");
				mxRedirect("modules.php?name=$module_name&amp;act=detail&amp;pic=$pic",_SG_VOTE_THANKS,3);
		        
		}
		mxRedirect("modules.php?name=$module_name&amp;act=detail&amp;pic=$pic",_SG_VOTE_ERR,3);
		
}

function sg_ViewLists($xlist,$page) {
    global $prefix, $currentlang,$module_name, $bgcolor1, $bgcolor2, $bgcolor3, $SGCFG,$mxConf,$pagetitle;
    
	/* das globale Template einstellen */
	$page=intval($page);
	
	$userdata = mxGetUserData();
	$userid=(MX_IS_USER)?$userdata['uid']:0;
	$pictures=array();
    $naviflag=true;
   switch($xlist) {
   	 default:
     case "newest": $title=_SG_NEWEST_PICTURES;
	      break;
     case "top": $title=_SG_TOPRATED_PICTURES;
	      break;
     case "mostviewed": $title=_SG_MOSTVIEWED_PICTURES;
	      break;
     case "random": $title=_SG_RANDOM_PICTURES;
	      $naviflag=false;
	      break;
     case "newcomments": $title=_SG_NEWCOMMENT_PICTURES;
	      break;
   }

	//$resultmax1=sg_getCategoryContent(0,$userid);
	
	
	$resultmax1=sg_getImagesListCountAll($xlist);
	
	$pictures=sg_getImagesList($xlist,($page*$SGCFG['FRONT_VIEWS']),$SGCFG['FRONT_VIEWS']);
	$picturescount=count($pictures);
	
	$maximage=(intval($SGCFG['FRONT_LISTS_COUNT'])==0)?$resultmax1: min($resultmax1,$SGCFG['FRONT_LISTS_COUNT']);//
	if (!$naviflag) $maximage=$picturescount;
	$pagestart=($page>0)?$page:0;
	$pagecount=($SGCFG['FRONT_VIEWS']>0)?intval($maximage/$SGCFG['FRONT_VIEWS'] +1 ):0;
	$prepage=($pagestart>0 && $SGCFG['FRONT_VIEWS']>0)?"modules.php?name=$module_name&amp;act=$xlist&amp;page=".($pagestart-1):"";
	$nextpage=($maximage>(($page+1)*intval($SGCFG['FRONT_VIEWS'])) && $SGCFG['FRONT_VIEWS']>0)?"modules.php?name=$module_name&amp;act=$xlist&amp;page=".($pagestart+1):"";
	
	$slideshowlink="";
	$seltemplate=$SGCFG['FRONT_TEMPLATE'];
	
	$pageheadtitle=$title;
	$pagesubtitle=$title;
	$breadcrump=sg_Breadcrump(0);
	
	$templatepath=PMX_MODULES_PATH .$module_name.DS."templates".DS.$seltemplate.DS;
	$defaulttemplate="default".DS;
	
	
	/* standardnamen im default-template initialisieren*/

	$view_detail=$seltemplate."detail.html";
	
	include('header.php');
	pmxHeader::add_style("modules".DS.$module_name.DS."style".DS."style.css");
	pmxHeader::add_style("modules".DS.$module_name.DS."style".DS."blocks.css");
	
	$templatename=$SGCFG['FRONT_TEMPLATE'];
	if (is_file("modules".DS .$module_name.DS."templates".DS.$templatename.DS."blocks.css")) {
	  pmxHeader::add_style("modules".DS.$module_name.DS."template".DS.$templatename.DS."blocks.css");
	} 

	$file_tempsettings=$templatepath."category.settings.php";
	if (file_exists($file_tempsettings)) include($file_tempsettings);
		
		

	/* Template initialisieren */
	$template = load_class('Template');
	$template->init_path(__FILE__);
	/* Daten dem Template zuweisen */
	$template->pagetitle = $pageheadtitle;
	$template->pagesubtitle = $pagesubtitle;
	$template->breadcrump = $breadcrump;
	$template->picturestitle = "";
	$template->searchlink="<a href=\"modules.php?name=$module_name&amp;act=search\" class=\"sgButton\">".SG_SEARCH."</a>";
	
	$template->pictures = $pictures;
	$template->picturescount = $picturescount;
	$template->slidelink=$slideshowlink;
	$template->modulname=$module_name;
	$template->adminlink=(MX_IS_ADMIN)?"<a href=\"admin.php?op=".$module_name."\" title=\""._ADMINMENUEBL."\" >["._ADMINMENUEBL."]</a>":"";
	
	
	/* fr Navigation */
	$template->page=$page+1 ;	
	$template->pages=$pagecount;
	$template->pagepre = $prepage;
	$template->pagenext= $nextpage;
	
	/* Template ausgeben (display) */
	
	if ($SGCFG['FRONT_BREADCRUMP']==1) $template->display('breadcrump.html');
	$template->display('pagestart.html');
	if ($SGCFG['FRONT_PAGES']!=1)  $template->display($view_navigation);
	
	//$template->display('navigation.html');
	$template->display($view_pictures);
	
		
	$template->display('pageend.html');	
	getAutoTemplate();
	include('footer.php');
   

}

function sg_ViewSearchList($search) {
    global $prefix, $currentlang,$module_name, $bgcolor1, $bgcolor2, $bgcolor3, $SGCFG,$mxConf,$pagetitle;
    
	
	$userdata = mxGetUserData();
	$userid=(MX_IS_USER)?$userdata['uid']:0;
	$pictures=array();

    $page=0;
	$title=SG_SEARCH;
    	
	$pictures=sg_getImagesSearch($search,0,$SGCFG['FRONT_LISTS_COUNT']);
	$picturescount=count($pictures);
	
	$maximage=$picturescount;
	$pagestart=($page>0)?$page:0;
	$pagecount=($SGCFG['FRONT_VIEWS']>0)?intval($maximage/$SGCFG['FRONT_VIEWS'] + 1 ):0;
	$prepage=($pagestart>0 && $SGCFG['FRONT_VIEWS']>0)?"modules.php?name=$module_name&amp;act=search&amp;keyword=$search&amp;page=".($pagestart-1):"";
	$nextpage=($maximage>(($page+1)*intval($SGCFG['FRONT_VIEWS'])) && $SGCFG['FRONT_VIEWS']>0)?"modules.php?name=$module_name&amp;act=search&amp;keyword=$search&amp;page=".($pagestart+1):"";
	
	$slideshowlink="";
	$seltemplate=$SGCFG['FRONT_TEMPLATE'];
	
	$pageheadtitle=$title;
	$pagesubtitle=$title;
	$breadcrump=sg_Breadcrump(0);
	
	$templatepath=PMX_MODULES_PATH .$module_name.DS."templates".DS.$seltemplate.DS;
	$defaulttemplate="default".DS;
	
	$searchform="";
	
	/* standardnamen im default-template initialisieren*/

	$view_detail=$seltemplate."detail.html";
	
	include('header.php');
	pmxHeader::add_style("modules".DS.$module_name.DS."style".DS."style.css");
	pmxHeader::add_style("modules".DS.$module_name.DS."style".DS."blocks.css");
	
	$templatename=$SGCFG['FRONT_TEMPLATE'];
	if (is_file("modules".DS .$module_name.DS."templates".DS.$templatename.DS."blocks.css")) {
	  pmxHeader::add_style("modules".DS.$module_name.DS."template".DS.$templatename.DS."blocks.css");
	} 
	$file_tempsettings=$templatepath."category.settings.php";
	if (file_exists($file_tempsettings)) include($file_tempsettings);
		
	$sform="";
	$sform.="<br /><form action=\"\"  name=\"searchForm\" method=\"get\" class=\"form\">";
	$sform.="<input type=\"hidden\" value=\"$module_name\" name=\"name\" />";
	$sform.="<input type=\"hidden\" value=\"search\" name=\"act\" />";
	$sform.="<input type=\"text\" value=\"$search\" name=\"keyword\" maxlength=\"64\" size=\"40\"/>";
	$sform.="<input type=\"submit\" value=\""._SEARCH."\" class=\"sgButton\"/>";
	$sform.="</form><br /><hr>";
		

	/* Template initialisieren */
	$template = load_class('Template');
	$template->init_path(__FILE__);
	/* Daten dem Template zuweisen */
	$template->pagetitle = $pageheadtitle;
	$template->pagesubtitle = $pagesubtitle;
	$template->breadcrump = $breadcrump;
	$template->picturestitle = "";
	$template->searchlink="&nbsp;";
	$template->searchdescription=SG_SEARCH_DESCRIPTION."<br/>";
	$template->modulname=$module_name;
	
	$template->pictures = $pictures;
	$template->picturescount = $picturescount;
	$template->slidelink=$slideshowlink;
	$template->adminlink=(MX_IS_ADMIN)?"<a href=\"admin.php?op=".$module_name."\" title=\""._ADMINMENUEBL."\" >["._ADMINMENUEBL."]</a>":"";
	
	$template->searchform=$sform;
	$template->searchresult=($search!="")?((strlen($search)>3)?SG_SEARCH_TEXT1."<i>".$search."</i>".SG_SEARCH_TEXT2.$picturescount.SG_SEARCH_TEXT3."<br/><hr>":SG_SEARCH_TOSHORT):"";
	
	/* fr Navigation */
	$template->page=$page+1 ;	
	$template->pages=$pagecount;
	$template->pagepre = $prepage;
	$template->pagenext= $nextpage;
	
	/* Template ausgeben (display) */
	
	if ($SGCFG['FRONT_BREADCRUMP']==1) $template->display('breadcrump.html');
	$template->display('pagestart.html');
	$template->display('search.html');
	
	$template->display($view_pictures);
	
		
	$template->display('pageend.html');	
	getAutoTemplate();
	include('footer.php');
   

}

?>